/* 
 * $Id: C-TEA.h,v 1.2 2004-02-27 17:19:48 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */
#ifndef _C_TEA_H
#define _C_TEA_H

enum TEA_pragma {
    TEA_TIMER = 100,
    TEA_LOG_FUNC = 101,
    TEA_LOG_EVENT = 102,
    TEA_LOG_BEGIN = 103,
    TEA_LOG_END = 104,
    TEA_FOR = 110,
    TEA_DATAMAP = 111,
    TEA_END = 120
};

#define IS_TEA_PRAGMA(p) \
(((int)(p)) >= (int)TEA_TIMER) && (((int)(p)) < (int)TEA_END)

enum TEA_for_clause {
    TEA_FOR_UNROLL = 0,
    TEA_FOR_BLOCK = 1
};

enum TEA_map_clause {
    TEA_MAP_NULL = 0,	/* * */
    TEA_MAP_EXPR = 1,	/* any expression */
    TEA_MAP_BLOCK = 2,	/* block */
    TEA_MAP_CYCLIC = 3	/* cyclic(N)*/
};

#endif /* _C_TEA_H */
