
/**
 * Local Variable Operand
 */
public class AddrOperand extends Operand {
  int offset;
  int regn;
  String name;

  /** constructor */
  public AddrOperand(int type, int regn, String name, int offset){
    super(Operand.ADDR,type);
    this.offset = offset;
    this.regn = regn;
    this.name = name;
  }

  /** get offset */
  public int getOffset() { return offset; }
  /** set offset */
  public void setOffset(int offset) { this.offset = offset; }

  /** get reg number */
  public int getRegN() { return regn;}
  /** set reg number */
  public void setRegN(int regn) { this.regn = regn; }

  /** get Name */
  public String getName() { return name; }
  /** set Name */
  public void setName(String name) { this.name = name; }
  
  public String toString(){
    if(name == null)
      return "[ADDR r"+regn+"+("+offset+")]";
    else
      return "[ADDR r"+regn+"+("+name+"+"+offset+")]";
  }
}
