
/**
 * Constant Operand
 */
public class ConstOperand extends Operand {
  int value;

  /** constructor */
  public ConstOperand(int type, int value){
    super(Operand.CONST,type);
    this.value = value;
  }

  /** constructor from constant Xobject */
  public ConstOperand(Xobject e){
    super(Operand.CONST,BasicType.ADDR);
  }

  /** get value */
  public int getValue() { return value; }
  /** set value */
  public void setValue(int value) { this.value = value; }

  public String toString(){
    return "[CONST "+value+"]";
  }
}


