// $Id: PointerType.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class PointerType extends Xtype {
  Xtype ref;
  
  public PointerType(int id, Xtype ref,int size,byte align,
		     boolean ic, boolean iv){
      super(Xtype.POINTER,id,size,align,ic,iv);
      this.ref = ref;
  }

  public PointerType(Xtype ref){
    super(Xtype.POINTER,0,Machine.pointerSize,Machine.pointerAlign,
	  false,false);
    if(ref.isArray()) this.ref = ref.getRef();
    else this.ref = ref;
  }
       
  public Xtype getRef() { return ref; }

  public Xtype copy() { 
    return new PointerType(0,ref,size,align,is_const,is_volatile);
  }

  public String toString(){
      return "P"+Integer.toHexString(type_id);
  }
}

