// $Id: Xobj.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

/**
 * class to define static methods to contruct Xobject
 */ 
public class Xobj {
    public static XobjString String(int code,Xtype type,String value){
	return new XobjString(code,type,value);
    }
    public static XobjString String(int code,String value){
	return new XobjString(code,value);
    }
    public static XobjString Symbol(int code,Xtype type,String value){
	return new XobjString(code,type,value);
    }
    public static XobjString Symbol(int code,String value){
	return new XobjString(code,value);
    }
    public static XobjInt Int(int code,Xtype type,int value){
	return new XobjInt(code,type,value);
    }
    public static XobjInt Int(int code,int value){
	return new XobjInt(code,value);
    }
    public static XobjLong Long(int code,Xtype type,long l){
	return new XobjLong(code,type,l);
    }
    public static XobjLong Long(int code,Xtype type,int high,int low){
	return new XobjLong(code,type,high,low);
    }
    public static XobjLong Float(int code,Xtype type,double d){
	return new XobjLong(code,type,d);
    }

    public static XobjList List(){
	return new XobjList();
    }
    public static XobjList List(int code,Xtype type){
	return new XobjList(code,type);
    }
    public static XobjList List(int code,Xtype type,Xobject a1){
	return new XobjList(code,type,a1);
    }
    public static XobjList List(int code,Xtype type,Xobject a1,Xobject a2){
	return new XobjList(code,type,a1,a2);
    }
    public static XobjList List(int code,Xtype type,Xobject a1,Xobject a2,Xobject a3){
	return new XobjList(code,type,a1,a2,a3);
    }
    public static XobjList List(int code,Xtype type,Xobject a1,Xobject a2,Xobject a3,Xobject a4){
	return new XobjList(code,type,a1,a2,a3,a4);
    }

    public static XobjList List(int code){
	return new XobjList(code);
    }
    public static XobjList List(int code,Xobject a1){
	return new XobjList(code,a1);
    }
    public static XobjList List(int code,Xobject a1,Xobject a2){
	return new XobjList(code,a1,a2);
    }
    public static XobjList List(int code,Xobject a1,Xobject a2,Xobject a3){
	return new XobjList(code,a1,a2,a3);
    }
    public static XobjList List(int code,Xobject a1,Xobject a2,Xobject a3,Xobject a4){
	return new XobjList(code,a1,a2,a3,a4);
    }
    public static XobjList emptyList(){
	return new XobjList(Xcode.LIST);
    }
    public static Ident Ident(String name,int stg_class,Xtype type, Xobject v){
	return new Ident(name,stg_class,type,v);
    }
}
