// $Id: XobjLong.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class XobjLong extends Xobject {
    long value;
    public XobjLong(int code,Xtype type,long l){
	super(code,type);
	value = l;
    }
    public XobjLong(int code,Xtype type,int high,int low){
	super(code,type);
	value = high;
	value = value << 32;
	long l = low;
	value = value | (l & 0xFFFFFFFFL);
    }
    public XobjLong(int code,Xtype type,double d){
	super(code,type);
	value = Double.doubleToLongBits(d);
    }
    public double getFloat(){
	return Double.longBitsToDouble(value);
    }
    public int getIntHIGH(){
	return (int)(value >> 32);
    }
    public int getIntLOW(){
	return (int)value;
    }
    public long getLong() {
	return value;
    }
    public Xobject copy(){
	return new XobjLong(code,type,value);
    }
    public boolean equals(Xobject x){
	return super.equals(x) && value == x.getLong();
    }
    public String toString(){
	return "("+OpcodeName()+" "+value+")";
    }
}


