// $Id: topdownXobjectIterator.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

import java.util.Stack;

public class topdownXobjectIterator extends XobjectIterator {
    Stack obj_stack;
    Stack arg_stack;

    public topdownXobjectIterator(Xobject x){
	topXobject = x;
    }

    public void init(Xobject x){
	obj_stack = new Stack();
	arg_stack = new Stack();
	currentXobject = x;
    }

    public void init(){ init(topXobject); }

    public void next(){
	if(currentXobject != null &&
	   currentXobject.Opcode() != Xcode.ID_LIST &&
	   currentXobject instanceof XobjList &&
	   currentXobject.getArgs() != null){
	    // save current top
	    obj_stack.push(currentXobject);
	    arg_stack.push(currentArgs);
	    currentArgs = currentXobject.getArgs();
	    currentXobject = currentArgs.getArg();
	    return;
	}
	while(!obj_stack.empty()){
	    currentArgs = currentArgs.nextArgs();
	    if(currentArgs != null){
		currentXobject = currentArgs.getArg();
		return;
	    }
	    obj_stack.pop();
	    currentArgs = (XobjArgs)arg_stack.pop();
	}
	currentXobject = null;
	return;
    }

    public boolean end() { 
	return currentXobject == null && obj_stack.empty();
    }
    public Xobject getParent() {
	if(obj_stack.empty()) return null;
	else return (Xobject)obj_stack.peek();
    }
}

