// $Id: OMPparallelBlock.java,v 1.2 2004-02-27 17:20:03 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.openmp;

import exc.block.*;
import exc.object.*;

//
// OpenMP parallel block
//
public class OMPparallelBlock extends OMPBlock {
  public OMPparallelBlock(int narg, BasicBlock setup,
			  BlockList body, Xobject cond){
    super(Xcode.OMP_PARALLEL,setup);
    setNarg(narg);
    setup.setExpr(cond); // set cond exp at end of setup bb.
    setBody(body);
  }
  
  public BasicBlock setupBasicBlock() { return getBasicBlock(); }
  public Xobject getIfExpr() { return beginBasicBlock().getExpr(); }
}





