// $Id: sample2.java,v 1.2 2004-02-27 17:20:04 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
import java.io.*;
import exc.object.*;

// sample2:
// 	rewrite VAR_ADDR/LVAR_ADDR/PARAM_ADDR -> VAR/LVAR/PARAM_VAR
//
public class sample2 implements XobjectDefVisitor {

  public void doDef(XobjectDef d){
    Xobject s;
    XobjectIterator i = new bottomupXobjectIterator(d.getDef());
    for(i.init(); !i.end(); i.next()){
      Xobject x = i.getXobject();
      if(x == null) continue;
      switch(x.Opcode()){
      case Xcode.VAR_ADDR:
	s = Xcons.Symbol(Xcode.VAR,x.Type(), x.getSym());
	i.setXobject(Xcons.List(Xcode.ADDR_OF,Xtype.Pointer(x.Type()),s));
	break;
      case Xcode.LVAR_ADDR:
	s = Xcons.Symbol(Xcode.LVAR,x.Type(), x.getSym());
	i.setXobject(Xcons.List(Xcode.ADDR_OF,Xtype.Pointer(x.Type()),s));
	break;
      case Xcode.PARAM_ADDR:
	s = Xcons.Symbol(Xcode.PARAM_VAR,x.Type(), x.getSym());
	i.setXobject(Xcons.List(Xcode.ADDR_OF,Xtype.Pointer(x.Type()),s));
	break;
      case Xcode.POINTER_REF:
	if(x.left().Opcode() == Xcode.ADDR_OF)
	  i.setXobject(x.left().left());
      }
    }
    d.setDef(i.topXobject());
  }

  //
  // main program of this phase
  //
  public static void main(String args[]){
    String infile = null;
    String outfile = null;
    
    if(args.length >= 1) infile = args[0];
    if(args.length >= 2) outfile = args[1];
    System.out.println("infile="+infile+",outfile="+outfile);
    XobjectFile f = new XobjectFile(infile,outfile);
    sample2 op = new sample2();

    f.Input();
    f.iterateFuncDef(op);
    f.Output();
    f.Decompile();
  }
}
