// $Id: sample4.java,v 1.2 2004-02-27 17:20:04 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
import java.io.*;
import exc.object.*;
import exc.block.*;

class sample4 /*TransPrintEnterMsg*/ implements XobjectDefVisitor {
   public void doDef(XobjectDef d){
      String fname = d.getName();
      Block fblock = Bcons.buildFunctionBlock(d);
      Ident printfId = 
        d.getFile().declExternIdent("printf",Xtype.Function(BasicType.intType));
      Xobject s = 
         printfId.Call(Xcons.List(Xcons.StringConstant("enter '"+fname+"'\\n")));
      fblock.getBody().getHead().getBody().insert(Bcons.Statement(s));
      d.setDef(fblock.toXobject());
   }

  public static void main(String args[]){
    String infile = null;
    String outfile = null;
    
    if(args.length >= 1) infile = args[0];
    if(args.length >= 2) outfile = args[1];
    System.out.println("infile="+infile+",outfile="+outfile);
    XobjectFile f = new XobjectFile(infile,outfile);
    sample4 op = new sample4();

    f.Input();
    f.iterateFuncDef(op);
    f.Decompile();
  }
}
