/* Config.java.c
 *
 * Run cpp to produce Config.java
 */
package scm;

public interface Config {
    static final String headerFile = HEADER;	/* ./f2c.h          */
    static final String parser = PARSER;	/* ../F-front/F-front.exe */
    static final String cpp = CPP;		/* gcc -E           */
    static final String shell = SHELL;		/* c:/cygwin/bin/sh */

    static final int offChipMemLatency  = 40;
    static final int busBandWidth       = 8;
    static final int onChipMemSize      = 8192;
    static final int onChipPageSize     = 4096;
    static final int strideLatency      = 40;
}
