package scmopt;

import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class canonicalizeExpr {

  public Xobject canonicalizeExpr(Xobject e) {
    Xobject s;
    XobjectIterator i = new bottomupXobjectIterator(e);
    for(i.init(); !i.end(); i.next()){
      Xobject x = i.getXobject();
      if(x == null) continue;
      // if type is null, don't care 
      if(x.isVarAddr() && x.Type() != null){
        i.setXobject(Xcons.AddrOf(Xcons.PointerRef(x)));
      } else if(x.Opcode() == Xcode.POINTER_REF &&
		x.left().Opcode() == Xcode.ADDR_OF)
        i.setXobject(x.left().left());
    }
    return i.topXobject();
  }
}
