/* 
 * $Id: ompd_tdl.h,v 1.1.1.1 2004-02-06 18:14:58 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */
#ifndef _OMPD_TDL_H
#define _OMPD_TDL_H
/* 
 * TDL library interface
 */
#include "tdl.h"
#include "tdl_debug.h"
#include <assert.h>

#define OMPD_TDL_READ 1
#define OMPD_TDL_WRITE 2

#define MAX_TDL_SCHED 16

typedef struct _ompd_TDL_com_schedule {
    char used;
    char rw_flag;
    short int n_rgn;
    ompd_access_range **rp;
    TDL_desc desc;
} ompd_TDL_comm_sched;

typedef struct _ompd_TDL_info {
    TDL_desc home_desc;
    TDL_desc current_desc; 	/* current distribution descriptor */
    int num_sched;
    ompd_TDL_comm_sched sched[MAX_TDL_SCHED];
} ompd_TDL_info;

#endif /* _OMPD_TDL_H */



