/*
 * $Id: tdl_list.h,v 1.1.1.1 2004-02-06 18:15:00 msato Exp $
 */

#ifndef __send_el_list__
#define __send_el_list__

struct _send_el
{
    unsigned long addr;
    unsigned long size;
};

typedef struct _send_el *Send_el;

int
eq_send_el(Send_el, Send_el);

struct _send_el_list;

typedef struct _send_el_list *Send_el_list;

struct _send_el_list {
    Send_el el;
    Send_el_list next;
};

/*
 *  Structure-dependent functions
 */

Send_el_list
cons_send_el(Send_el, Send_el_list);

void
delete_send_el(Send_el_list);

void
print_send_el(Send_el_list);

Send_el_list
insert_sorted_send_el(Send_el el, Send_el_list ls);

/*
 *  Structure-indenpendent functions
 */

Send_el
car_send_el(Send_el_list);

Send_el_list
cdr_send_el(Send_el_list);

Send_el_list
append_send_el(Send_el_list, Send_el_list);

Send_el
nth_send_el(int, Send_el_list);

int
length_send_el(Send_el_list);

Send_el_list
remove_send_el(Send_el, Send_el_list);

Send_el_list
uniq_send_el(Send_el_list);

Send_el_list
reverse_send_el(Send_el_list);

Send_el_list
copy_send_el(Send_el_list);

Send_el_list
member_send_el(Send_el, Send_el_list);

#endif
