#include <stdio.h>
#include "scm.h"

extern void __Omni_FortranEntryPoint();

main() {
    __Omni_FortranEntryPoint();
}

void* scm_alloc(int s) {
    return (void*)malloc(s);
}

void scm_free(void* p) {
    free(p);
}

void scm_load(void* src, void* dest, int size, int num, int stride) {
    int i, k;
    char *srcp, *destp;
    srcp = (char*)src;
    destp = (char*)dest;
    for (i = 0; i < num; ++i) {
	for (k = 0; k < size; ++k)
	    *destp++ = srcp[k];

	srcp += size * (stride + 1);
    }
}

void scm_store(void* src, void* dest, int size, int num, int stride) {
    int i, k;
    char *srcp, *destp;
    srcp = (char*)src;
    destp = (char*)dest;
    for (i = 0; i < num; ++i) {
	for (k = 0; k < size; ++k)
	    destp[k] = *srcp++;

	destp += size * (stride + 1);
    }
}

void scm_printd_(double* d) {
    printf("%.1f ", *d);
}

void scm_printi_(int* i) {
    printf("%d ", *i);
}

void scm_println_() {
    putchar('\n');
}
