static char rcsid[] = "$Id: attr003.c,v 1.1.1.1 2004-02-06 18:15:07 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* attribute 003 :
 * parallel region staticѿ shared ˤʤǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


func ()
{
  static int	shrd = 0;

  #pragma omp critical
  {
    shrd += 1;
  }

  #pragma omp barrier
  if (shrd != thds) {
    #pragma omp critical
    errors += 1;
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel
  {
    static int	shrd = 0;

    #pragma omp critical
    {
      shrd += 1;
    }

    #pragma omp barrier
    if (shrd != thds) {
      #pragma omp critical
      errors += 1;
    }
  }


  #pragma omp parallel
  func ();


  if (errors == 0) {
    printf ("attribute 003 : SUCCESS\n");
    return 0;
  } else {
    printf ("attribute 003 : FAILED\n");
    return 1;
  }
}
