static char rcsid[] = "$Id: err_copyin_007.c,v 1.1.1.1 2004-02-06 18:15:08 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of copyin 007 :
 * ordered Ф copyin 򤷤ưǧ
 */

#include "omniConfig.h"
#include <omp.h>


int	errors = 0;
int	thds;


int	org;
int	prvt;
#pragma omp threadprivate(prvt)


main ()
{
  int	i;

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  prvt = org = 1;

  #pragma omp parallel for ordered
  for (i=0; i<thds; i++) {
    #pragma omp ordered copyin (prvt)
    {
      if (prvt != org) {
	errors += 1;
      }
    }
  }


  printf ("err_copyin 007 : FAILED, can not compile this program.\n");
  return 1;
}
