static char rcsid[] = "$Id: fstprvt023.c,v 1.1.1.1 2004-02-06 18:15:09 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* firstprivate 023 :
 * sctions  firstprivate Ǥ뤳Ȥǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define MAGICNO	100


int	errors = 0;
int	thds;

int	prvt = MAGICNO;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel sections firstprivate (prvt)
  {
    #pragma omp section
    {
      int id = omp_get_thread_num ();
      if (prvt != MAGICNO) {
        #pragma omp critical
	errors += 1;
      }
      prvt = id;
      if (prvt != id) {
	#pragma omp critical
	errors += 1;
      }
    }
    #pragma omp section
    {
      int id = omp_get_thread_num ();
      if (prvt != MAGICNO) {
        #pragma omp critical
	errors += 1;
      }
      prvt = id;
      if (prvt != id) {
	#pragma omp critical
	errors += 1;
      }
    }
  }


  if (errors == 0) {
    printf ("firstprivate 023 : SUCCESS\n");
    return 0;
  } else {
    printf ("firstprivate 023 : FAILED\n");
    return 1;
  }
}
