static char rcsid[] = "$Id: fstprvt025.c,v 1.1.1.1 2004-02-06 18:15:09 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* firstprivate 025 :
 * firstprivatelastprivateƱѿФ줿ưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define MAGICNO		100

int	errors = 0;
int	thds;

int	prvt;


main ()
{
  int	i;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  prvt = MAGICNO;
  #pragma omp parallel for firstprivate (prvt) lastprivate (prvt)
  for (i=0; i<thds; i++) {
    prvt += i;
  }
  if (prvt != thds - 1 + MAGICNO) {
    errors += 1;
  }


  if (errors == 0) {
    printf ("firstprivate 025 : SUCCESS\n");
    return 0;
  } else {
    printf ("firstprivate 025 : FAILED\n");
    return 1;
  }
}
