static char rcsid[] = "$Id: err_private_004.c,v 1.1.1.1 2004-02-06 18:15:10 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of private 004 :
 * threadprivate 줿ѿ private 줿ưǧ
 */

#include "omniConfig.h"
#include <omp.h>


int	errors = 0;
int	thds;


int	prvt;
#pragma omp threadprivate (prvt)


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel private (prvt)
  {
    int	id = omp_get_thread_num ();

    prvt = id;
    #pragma omp barrier

    if (prvt != id) {
      errors += 1;
    }
  }


  printf ("err_private 004 : FAILED, can not compile this program.\n");
  return 1;
}
