static char rcsid[] = "$Id: prvt005.c,v 1.2 2004-10-14 08:23:20 a-hasega Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* private 005 :
 * shared ѿϡprivate ˽롣
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


int	prvt;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel shared(prvt)
  {
    int	id = omp_get_thread_num ();

    #pragma omp sections private(prvt)
    {
      #pragma omp section
      {
	prvt = id;
	barrier (2);
	if (prvt != id) {
          #pragma omp critical
	  errors += 1;
	}
      }
      #pragma omp section
      {
	prvt = id;
	barrier (2);
	if (prvt != id) {
          #pragma omp critical
	  errors += 1;
	}
      }
    }
  }

  if (errors == 0) {
    printf ("private 005 : SUCCESS\n");
    return 0;
  } else {
    printf ("private 005 : FAILED\n");
    return 1;
  }
}
