static char rcsid[] = "$Id: err_reduction_022.c,v 1.1.1.1 2004-02-06 18:15:12 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of reduction 022 :
 * reduction ǻꤵ줿 operation ȱ黻ۤʤ硣
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


int	rdct;


main ()
{
  int i;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct += 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct -= 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct *= 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct &= 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct |= 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct ^= 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct = rdct && 1;
  }

  #pragma omp parallel for reduction(||:rdct)
  for (i=0; i<thds; i++) {
    rdct = rdct || 1;	
  }


  printf ("err_reduction 022 : FAILED, can not compile this program.\n");
  return 1;
}
