static char rcsid[] = "$Id: sngl003.c,v 1.1.1.1 2004-02-06 18:15:19 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* single 003:
 * nowait ꤷưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	thds, flag;

int	errors = 0;


void
func_single ()
{
  #pragma omp barrier

  #pragma omp single nowait
  {
    int thds = omp_get_num_threads ();
    do {
      #pragma omp flush (flag)
    } while (flag != thds-1);
  }

  #pragma omp critical
  {
    flag += 1;
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  flag = 0;
  #pragma omp parallel
  {
    #pragma omp barrier

    #pragma omp single nowait
    {
      int thds = omp_get_num_threads ();
      do {
        #pragma omp flush (flag)
      } while (flag != thds-1);
    }

    #pragma omp critical
    {
      flag += 1;
    }
  }


  flag = 0;
  #pragma omp parallel
  {
    func_single ();
  }


  if (errors == 0) {
    printf ("single 003 : SUCCESS\n");
    return 0;
  } else {
    printf ("single 003 : FAILED\n");
    return 1;
  }
}
