static char rcsid[] = "$Id: tst_lck002.c,v 1.1.1.1 2004-02-06 18:15:34 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* omp_test_lock 002:
 * åɴ֤ǡomp_test_lockؿưǧޤ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


main ()
{
  omp_lock_t	lck;
  int		thds;
  int		s,f;

  int		errors = 0;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi thread.\n");
    exit (0);
  }

  omp_init_lock(&lck);
  s = f = 0;

  #pragma omp parallel
  {
    int	t;

    t = omp_test_lock (&lck);
    if (t != 0) {
      /* lock successful */
      #pragma omp critical
      s += 1;
    } else {
      /* lock fail */
      #pragma omp critical
      f += 1;
    }
  }

  if (s != 1) {
    errors += 1;
  }
  if (f != thds - 1) {
    errors += 1;
  }


  if (errors == 0) {
    printf ("omp_test_lock 002 : SUCCESS\n");
    return 0;
  } else {
    printf ("omp_test_lock 002 : FAILED\n");
    return 1;
  }
}
