// $Id: omp_decompile.java,v 1.1.1.1 2004-02-06 18:17:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
import java.io.*;
import exc.object.*;
import exc.openmp.*;

//
//      convert .x file to .c
//
public class omp_decompile {
  public static void main(String args[]){
    String infile = null;
    String outfile = null;

    if(args.length >= 1) infile = args[0];
    if(args.length >= 2) outfile = args[1];
    System.out.println("infile="+infile+",outfile="+outfile);
    XobjectFile f = new XobjectFile(infile,outfile);
    f.Input();

    OMPtransFunction op = new OMPtransFunction();
    op.init(f);
    f.iterateDef(op); // transform OMP pragma
    if(OMP.errorFlags){
      System.err.println("error in OpenMP. stop.");
      System.exit(1);
    }
    if(outfile != null) f.Output();
    f.Decompile();
  }
}

