/* 
 * $Id: C-pragma.h,v 1.1.1.1 2004-02-06 18:13:08 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* pragma */
#include "C-OMP.h"
#ifdef USE_TEA_PRAGMA
#include  "C-TEA.h"
#endif /* USE_TEA_PRAGMA */
#ifdef USE_OPENGR_PRAGMA
#include "C-OGR.h"
#endif /* USE_OPENGR_PRAGMA */

/* syntax property of pragma */
enum pragma_syntax {
    SYN_PRAGMA_NONE = 0,
    SYN_PRAGMA_DECL,
    SYN_PRAGMA_EXEC,
    SYN_PRAGMA_PREFIX,
    SYN_PRAGMA_POSTFIX
};

#define MAX_TOKEN_LEN 65536

#define PG_CONST 'N'
#define PG_ERR 'E'
#define PG_IDENT 'I'
#define PG_ANDAND 'A'
#define PG_OROR 'O'
#define PG_EQEQ  'P'
#define PG_NEQ 'Q'
#define PG_LTEQ 'T'
#define PG_GTEQ 'U'
#define PG_LTLT 'V'
#define PG_GTGT 'W'
#define PG_STREF 'S'

extern char *pg_cp;
extern char pg_tok;		/* current token */
extern char pg_tok_buf[];
#define PG_IS_IDENT(name)	(pg_tok == 'I' && strcasecmp(name,pg_tok_buf) == 0)
extern expr pg_args;

#define PG_LIST0(pg) list1(LIST, make_enode(INT_CONSTANT, (void *)((_omAddrInt_t)pg)))
#define PG_LIST1(pg,arg) list2(LIST, make_enode(INT_CONSTANT, (void *)((_omAddrInt_t)pg)), arg)
