// $Id: PragmaBlock.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.block;
import exc.object.*;

//
// for pragma
//
public class PragmaBlock extends CompoundBlock {
  int pragma;
  Xobject args;

  // statement block with null BasicBlock
  public PragmaBlock(int code, int pragma, Xobject args,BlockList body){
    super(code,body);
    this.code = code;
    this.pragma = pragma;
    this.args = args;
  }

  public int getPragma() { return pragma; }
  public Xobject getClauses() { return args; }

  public Xobject toXobject() {
    Xobject x = new XobjList(Opcode(),
			     new XobjInt(Xcode.INT_CONSTANT,pragma),
			     args,super.toXobject());
    x.setLineNo(getLineNo());
    return x;
  }
}

