// $Id: optFuncDefBlock.java,v 1.2 2004-02-27 17:20:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.flow;

import exc.object.*;
import exc.block.*;
import java.util.*;

//
// Function Definition Block for Optimizer
//   with temporary variable management
//   with control flow graph
//
public class optFuncDefBlock extends optBodyEnv {
  FuncDefBlock fd;

  // in C, expose AsgExpr 
  protected boolean enableExposeAsgExpr = true;

  public optFuncDefBlock(FuncDefBlock fd){
    super(fd.getBlock().getBody().getHead().getBody());
    this.fd = fd;
    init();
  }

  public optFuncDefBlock(FuncDefBlock fd,boolean flag){
    super(fd.getBlock().getBody().getHead().getBody());
    this.fd = fd;
    enableExposeAsgExpr = flag;
    init();
  }

  protected void init(){
    if(enableExposeAsgExpr) exposeAsgExpr();
    makeCFG();
  }
}

