
import exc.block.*;

/** 
 * interface to emit Inst(LIR) environment
 */
public interface EmitInstEnv {
  /** Generate a new pseudo register */
  public int genRegN();

  /** Generate label ID */
  public int genLabel();

  /** Generate LIR code */
  public void emit(Inst i);
}

