// $Id: ArrayType.java,v 1.2 2004-02-27 17:20:01 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class ArrayType extends Xtype {
  Xtype ref;
  int dim;
  Xobject asize;

  public ArrayType(int id,Xtype ref,int dim,int size,byte align,
		   boolean ic,boolean iv,Xobject asize){
      super(Xtype.ARRAY,id,size,align,ic,iv);
      this.ref = ref;
      this.dim = dim;
      this.asize = asize;
  }

  public ArrayType(Xtype ref,int dim){
    super(Xtype.ARRAY,0,ref.getSize(),ref.getAlign(),false,false);
    this.ref = ref;
    this.dim = dim;
  }

  public Xtype getRef() { return ref; }
  public int getArrayDim() { return dim; }
  public Xobject getArrayAdjSize() { return asize; }

  public int getNumDimensions() {  return ref.getNumDimensions()+1;  }

  public Xtype getArrayElementType() { 
    if(ref.isArray()) return ref.getArrayElementType();
    else return ref;
  }

  public Xtype copy() { 
    return new ArrayType(0,ref,dim,size,align,is_const,is_volatile,asize);
  }

  public String toString(){
      return "A"+ Integer.toHexString(type_id);
  }
}

