// $Id: EnumType.java,v 1.2 2004-02-27 17:20:01 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class EnumType extends Xtype {
  Ident tag_name;
  Xobject moe_list;
  EnumType copy_ref;

  public EnumType(int id,Xobject moe_list,int size,byte align,
		  boolean ic, boolean iv){
      super(Xtype.ENUM,id,size,align,ic,iv);
      this.moe_list = moe_list;
  }

  public boolean isIntegral() { return true; }
  public Xobject getMoeList() { return moe_list; }
  public void setTagIdent(Ident name) { tag_name = name; }
  public Ident getTagIdent() { 
    if(tag_name == null){
      if(copy_ref != null) return copy_ref.getTagIdent();
      return null;
    }
    return tag_name; 
  }
  public String getTagName() {
    Ident id = getTagIdent();
    return id == null ? null : id.getName(); 
  }
  public Xtype copy() { 
    EnumType t = new EnumType(0,moe_list,size,align,is_const,is_volatile);
    t.copy_ref = this;
    return t;
  }
  public String toString(){
      return "E"+ Integer.toHexString(type_id);
  }
}
