// $Id: LineNo.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class LineNo {
  String fname;
  int ln;

  static LineNo current_lineno;

  public LineNo(String fname,int ln){
    this.fname = fname.intern();
    this.ln = ln;
  }
  
  public int lineNo() { return ln; }
  public String fileName() { return fname; }

  public static LineNo make(String fname,int ln){
    if(current_lineno == null ||
       current_lineno.ln != ln ||
       !current_lineno.fname.equals(fname)){
      if(fname == null) {
	if(current_lineno == null) fname = "*";
	else fname = current_lineno.fname;
      }
      current_lineno =  new LineNo(fname,ln);
    }
    return current_lineno;
  }
}

