// $Id: UnionType.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class UnionType extends Xtype {
  Ident tag_name;
  Xobject id_list;
  UnionType copy_ref;

  public UnionType(int id, Xobject id_list, int size,byte align,
	boolean ic, boolean iv){
      super(Xtype.UNION,id,size,align,ic,iv);
      this.id_list = id_list;
  }
  public Xobject getMemberList() { return id_list; }
  public void setTagIdent(Ident name) { tag_name = name; }
  public Ident getTagIdent() { 
    if(tag_name == null){
      if(copy_ref != null) return copy_ref.getTagIdent();
      return null;
    }
    return tag_name; 
  }
  public String getTagName() {
    Ident id = getTagIdent();
    return id == null ? null : id.getName(); 
  }
  public Xtype copy() { 
    UnionType t =  new UnionType(0,id_list,size,align,is_const,is_volatile);
    t.copy_ref = this;
    return t;
  }
  public String toString(){
      return "U"+ Integer.toHexString(type_id);
  }
}

