// $Id: XobjInt.java,v 1.2 2004-02-27 17:20:02 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.object;

public class XobjInt extends Xobject {
  int value;
  public XobjInt(int code,Xtype type,int value){
    super(code,type);
    this.value = value;
  }
  public XobjInt(int code,int value){
    super(code,null);
    this.value = value;
  }
  public int getInt(){
    return value;
  }
  public Xobject copy(){
    return new XobjInt(code,type,value);
  }
  public boolean equals(Xobject x){
    return super.equals(x) && value == x.getInt();
  }
  public String getName(){
    if(code == Xcode.REG) return "_r_"+Integer.toHexString(value);
    else return Integer.toString(value);
  }
  public String toString(){
    return "("+OpcodeName()+" "+Integer.toHexString(value)+")";
  }
}


