// $Id: TEA.java,v 1.2 2004-02-27 17:20:03 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
package exc.tea;

import exc.object.*;

//
// for tea pragma
//
public class TEA {
  public final static int TIMER = 100;
  public final static int LOG_FUNC = 101;
  public final static int LOG_EVENT = 102;
  public final static int LOG_BEGIN = 103;
  public final static int LOG_END = 104;
  public final static int FOR = 110;
  public final static int DATAMAP = 111;

  public final static int FOR_UNROLL = 0;
  public final static int FOR_BLOCK = 1;

  public final static int MAP_NONE = 0;   /* * */
  public final static int MAP_EXPR = 1;   /* any expression */
  public final static int MAP_BLOCK = 2;  /* block */
  public final static int MAP_CYCLIC = 3; /* cyclic(N)*/

  public final static String mapProp = "TEA_mapping_info";

  public static String pragmaName(int pg){
    switch(pg){
    case TIMER:
      return "TIMER";
    case LOG_FUNC:
      return "LOG_FUNC";
    case LOG_EVENT:
      return "LOG_EVENT";
    case LOG_BEGIN:
      return "LOG_BEGIN";
    case LOG_END:
      return "LOG_END";
    case FOR:
      return "LOG_FOR";
    case DATAMAP:
      return "DATAMAP";
    default:
      return "???";
    }
  }
}


