// $Id: sample3.java,v 1.2 2004-02-27 17:20:04 msato Exp $
// $RWC_Release$
// $RWC_Copyright$
import java.io.*;
import exc.object.*;

// sample3:
// 	print Variable names in Function
//
class sample3 /* PrintVarRef */ implements XobjectDefVisitor {

  public void doDef(XobjectDef d){
    String fname = d.getName();
    XobjectIterator i = new topdownXobjectIterator(d.getFuncBody());
    for(i.init();!i.end(); i.next()){
      Xobject x = i.getXobject();
      if(x == null) continue;
      if(x.isVariable() || x.isVarAddr())
	System.out.println("Variable '"+x.getName()+
			   "' is referenced from Function '"+fname+"'");
    }
  }

  public static void main(String args[]){
    String infile = null;
    String outfile = null;
    
    if(args.length >= 1) infile = args[0];
    if(args.length >= 2) outfile = args[1];
    System.out.println("infile="+infile+",outfile="+outfile);
    XobjectFile f = new XobjectFile(infile,outfile);

    sample3 op = new sample3();

    f.Input();
    f.iterateFuncDef(op);
  }
}
