/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
package scm;

import java.io.*;
import exc.object.*;

/*
 * Decompiler to C source from Xobject including SCIMA pragmas.
 */
public class ScmDecompileWriter extends XobjectDecompileWriter {

    public ScmDecompileWriter(Writer fout, XobjectFile xfile) {
	super(fout, xfile);
    }

    /* (SCM_PRAGMA (IDENT <before code>) <xobject> (IDENT <after code>))
     */
    public void printUserCode(Xobject xobj){
	if (xobj.Opcode() == Xcode.SCM_PRAGMA_CODE) {
	    printIfnonNull(xobj.getArg(0));
	    print(xobj.getArg(1));
	    printIfnonNull(xobj.getArg(2));
	    return;
	}

	throw new RuntimeException("unknown xobj: " + xobj);
    }

    private void printIfnonNull(Xobject p) {
	if (p != null)
	    print(p.getSym());
    }
}
