package scmopt;

import scm.*;
import exc.object.*;
import exc.block.*;
import exc.flow.*;

public class insertPragmas {

  public Xobject insertBegin(String array, XobjList list, Xobject body) {
    Xobject obj;
    obj = Xcons.List(Xcode.SCM_PRAGMA, 
		     Xcons.Symbol(Xcode.IDENT, "begin_"), 
		     Xcons.Symbol(Xcode.IDENT, array), 
		     list,
		     body);
    //System.out.println(obj);

    return obj;
  }

  public Xobject insertLoad(String array, XobjList list) {
    Xobject obj;
    obj = Xcons.List(Xcode.SCM_PRAGMA, 
		     Xcons.Symbol(Xcode.IDENT, "load_"), 
		     Xcons.Symbol(Xcode.IDENT, array), 
		     list);
    //System.out.println(obj);

    return obj;
  }

  public Xobject insertStore(String array) {
    Xobject obj;
    obj = Xcons.List(Xcode.SCM_PRAGMA, 
		     Xcons.Symbol(Xcode.IDENT, "store_"), 
		     Xcons.Symbol(Xcode.IDENT, array));
    //System.out.println(obj);

    return obj;
  }
}
