#include <stdio.h>
#include "ompd_object.h"

/* 
 * test _ompc_do_parallel (with arguments), _rmem_read_int
 */

void test_f(void **args);

_ompc_main(int argc,char *argv[])
{
    int i;
    int x,y;
    void *args[2];
    
    printf("master begin...\n");
    x = 100;
    y = 200;
    
    for(i = 0; i < 4; i++){
	args[0] = (void *)&x;
	args[1] = (void *)&y;
	_ompc_do_parallel(test_f,args,2);
	x += 10;
	y += 20;
    }
    printf("master end ...\n");
}

void test_f(void **args)
{
    int *xp,*yp;
    int xx,yy;

    xp = (int *)(args[0]);
    yp = (int *)(args[1]);
    xx = _rmem_read_int(xp);
    yy = _rmem_read_int(yp);
    printf("hello id=%d, xx=%d, yy=%d\n",
	   omp_get_thread_num (), xx, yy);
}


