/* 
 * $PCCC_Release$
 * $PCCC_Copyright$
 */
static char rcsid[] = "$Id: scash_dirty_page.c,v 1.2 2004-04-05 08:29:22 ojima Exp $";

#include  <stdio.h>
#include  <fcntl.h>
#include  <unistd.h>
#include  <stdlib.h>
#include  <string.h>
#include  <errno.h>
#include  <signal.h>
#include  <sys/types.h>
#include  <sys/mman.h>
#include  <errno.h>

#include  "scash.h"
#include  "scash_private.h"

dirty_page_t    *dirty_page;

void
scash_dp_init()
{
    while( scash_inbox_try_lock(0, (void*)(&dirty_page->lock_bit))) {
        ;
    }
    dirty_page->total = 0;
    scash_inbox_unlock(0, (void*)(&dirty_page->lock_bit));
}

void 
scash_dp_insert(u_int  page)
{
    while( scash_inbox_try_lock(0, (void*)(&dirty_page->lock_bit))) {
        ;
    }

    dirty_page->dp[dirty_page->total++] = page;

    scash_inbox_unlock(0, (void*)(&dirty_page->lock_bit));
} 
