/* 
 * $PCCC_Release$
 * $PCCC_Copyright$
 */
static char rcsid[] = "$Id: scash_inbox.c,v 1.3 2004-08-20 09:44:05 msato Exp $";

#include  <stdio.h>
#include  <fcntl.h>
#include  <unistd.h>
#include  <stdlib.h>
#include  <string.h>
#include  <errno.h>
#include  <signal.h>
#include  <sys/types.h>
#include  <sys/mman.h>
#include  <sched.h>

#define  __SMP__
#define  CONFIG_SMP
#define _LINUX_CONFIG_H
#define extern  static
#include  <asm/bitops.h>
#undef  extern
#endif

#ifndef smp_mb__before_clear_bit
#define smp_mb__before_clear_bit()
#endif

#ifndef smp_mb__after_clear_bit
#define smp_mb__after_clear_bit()
#endif

/*
#include  <score_resource.h>
*/
void
scash_inbox_init_lock(int  bp, void  *lockp)
{
  smp_mb__before_clear_bit();
  clear_bit(bp, lockp);
  smp_mb__after_clear_bit();
}

void
scash_inbox_unlock(int  bp, void  *lockp)
{
  smp_mb__before_clear_bit();
  clear_bit(bp, lockp);
  smp_mb__after_clear_bit();
}

void
scash_inbox_spin_lock(int  bp, void  *lockp)
{
  while ( test_and_set_bit(bp, lockp) )
    ;
}

int
scash_inbox_try_lock(int  bp, void  *lockp)
{
  return test_and_set_bit(bp, lockp);
}


