#include <stdio.h>
#include  <sys/types.h>
#include "scash.h"
#include "scash_private.h"

void
scash_stats_init()
{
    scash.stat_cnt++;
    scash.stats++;
}

void
scash_init_stats_all()
{
    int  i, cnt;

    for (cnt = 0 ; cnt < SCASH_MAX_STATS ; cnt++ ) {
	scash_stats[cnt].sigvm_cnt = 0;
	for (i = 0 ; i < 4 ; i++)
	    scash_stats[cnt].sigvm_clock[i] = 0;
	
	scash_stats[cnt].sigio_cnt = 0;
	scash_stats[cnt].sigio_clock = 0;
	scash_stats[cnt].diff_cnt = 0;
	scash_stats[cnt].flush_cnt[0] = 0;
	scash_stats[cnt].flush_cnt[1] = 0;
	scash_stats[cnt].flush_clock[0] = 0;
	scash_stats[cnt].flush_clock[1] = 0;
	scash_stats[cnt].barrier_cnt = 0;

	scash_stats[cnt].read_fault_cnt = 0;
	scash_stats[cnt].read_fault_clock = 0;

	scash_stats[cnt].read_page_on_read_cnt = 0;
	scash_stats[cnt].read_page_on_read_clock = 0;
	scash_stats[cnt].read_page_on_write_cnt = 0;
	scash_stats[cnt].read_page_on_write_clock = 0;

	scash_stats[cnt].read_page_cnt = 0;
	scash_stats[cnt].read_page_clock1 = 0;
	scash_stats[cnt].read_page_clock2 = 0;
	scash_stats[cnt].read_page_clock3 = 0;

	scash_stats[cnt].update_page_cnt = 0;
	scash_stats[cnt].update_page_clock = 0;
	
	scash_stats[cnt].write_fault_cnt = 0;
	scash_stats[cnt].write_fault_clock = 0;

	scash_stats[cnt].twin_cnt = 0;
	scash_stats[cnt].twin_clock = 0;

	for (i = 0 ; i < 6 ; i++) {
	    scash_stats[cnt].barrier_clock[i] = 0;
	    scash_stats[cnt].barrier_max[i] = scash_stats[cnt].barrier_max_cnt[i] = 0;
	    scash_stats[cnt].barrier_min[i] = scash_stats[cnt].barrier_min_cnt[i] = 0;
	}

	scash_stats[cnt].s_bar_cnt = 0;
	scash_stats[cnt].s_bar_msg_cnt[0] = scash_stats[cnt].s_bar_msg_cnt[1] = 0;
	for (i = 0 ; i < 4 ; i++) {
	    scash_stats[cnt].s_bar_clock[i] = 0;
	    scash_stats[cnt].s_bar_max[i] = scash_stats[cnt].s_bar_max_cnt[i] = 0;
	    scash_stats[cnt].s_bar_min[i] = scash_stats[cnt].s_bar_min_cnt[i] = 0;
	}

	for (i = 0 ; i < 8 ; i++)
	    scash_stats[cnt].diff_size[i] = 0;

	for (i = 0 ; i < 8 ; i++)
	    scash_stats[cnt].diff_size[i] = 0;

	scash_stats[cnt].update_cnt = 0;
	scash_stats[cnt].update_word_cnt = 0;
	for (i = 0 ; i < 4 ; i++) {
	  scash_stats[cnt].update_clock[i] = 0;
	  scash_stats[cnt].update_word_clock[i] = 0;
	}

	scash_stats[cnt].lock_cnt = 0;
	scash_stats[cnt].unlock_cnt = 0;
	for (i = 0 ; i < 5 ; i++) {
	  scash_stats[cnt].lock_clock[i] = 0;
	  scash_stats[cnt].unlock_clock[i] = 0;
	}

	scash_stats[cnt].poll_cnt = 0;
	scash_stats[cnt].poll_clock = 0;

	scash_stats[cnt].waite_cnt = 0;
	scash_stats[cnt].waite_clock = 0;

	scash_stats[cnt].home_read_cnt = 0;
	scash_stats[cnt].home_move_cnt = 0;
    }
}

u_int64  scash_rdtsc()
{
  
}
