
typedef  struct  scash_stats_s {
    u_int    barrier_cnt;
    u_int64    barrier_clock[10];
    u_int    barrier_max[10];
    u_int    barrier_max_cnt[10];
    u_int    barrier_min[10];
    u_int    barrier_min_cnt[10];

    u_int    s_bar_cnt;
    u_int    s_bar_msg_cnt[2];
    u_int    s_bar_clock[4];
    u_int    s_bar_max[4];
    u_int    s_bar_max_cnt[4];
    u_int    s_bar_min[4];
    u_int    s_bar_min_cnt[4];

    u_int    sigio_cnt;
    u_int    sigio_clock;
    u_int    sigvm_cnt;
    u_int    sigvm_clock[4];
    u_int    read_fault_cnt;
    u_int    read_fault_clock;
    u_int    read_page_on_read_cnt; 
    u_int    read_page_on_read_clock; 
    u_int    read_page_on_write_cnt; 
    u_int    read_page_on_write_clock; 
    u_int    read_page_cnt; 
    u_int    read_page_clock1; 
    u_int    read_page_clock2; 
    u_int    read_page_clock3;
    
    u_int    update_page_cnt;
    u_int64    update_page_clock;

    u_int    write_fault_cnt;
    u_int    write_fault_clock;
    u_int    twin_cnt;
    u_int    twin_clock;
    u_int    diff_cnt;
    u_int    flush_cnt[2];
    u_int64  flush_clock[2];
    u_int    diff_size[8];

    u_int    update_cnt;
    u_int64  update_clock[4];
    u_int    update_word_cnt;
    u_int64  update_word_clock[4];

    u_int    lock_cnt;
    u_int64  lock_clock[5];
    u_int    unlock_cnt;
    u_int64  unlock_clock[5];

    u_int    poll_cnt;
    u_int64  poll_clock;

    u_int    waite_cnt;
    u_int64  waite_clock;

    u_int    home_read_cnt;
    u_int    home_move_cnt;
}scash_stats_t;
