// $Id: tlogInit.java,v 1.2 2005-11-04 06:53:04 ojima Exp $
// $Release$
// $Copyright$

import java.awt.*;

public class tlogInit {
    final static byte START_EVENT = 9;

    final static byte BARRIER_IN = 10;
    final static byte BARRIER_OUT = 11;

    final static byte MSGH_IN = 12;
    final static byte MSGH_OUT = 13;

    final static byte SEND_IN = 14;
    final static byte SEND_OUT = 15;
    
    final static byte PAGEF_IN = 16;
    final static byte PAGEF_OUT = 17;

    final static byte BSYNC_IN = 18;
    final static byte BSYNC_OUT = 19;

    final static byte FLUSH_ALL_IN = 20;
    final static byte FLUSH_ALL_OUT = 21;

    final static byte PAGE_INV_IN = 22;
    final static byte PAGE_INV_OUT = 23;

    final static byte PAGEF_EVENT = 24;
    final static byte RMA_EVENT = 30;

    final static byte MPI_SEND_EVENT = 37;
    final static byte MPI_RECV_EVENT = 38;
    final static byte MPI_RMA_EVENT = 40;
    
  public static void init() {
    tlogData.setMaxType(41);

    tlogData.defineEvent2Type(BARRIER_IN,BARRIER_OUT,"barrier",Color.white);
    tlogData.defineEvent2Type(MSGH_IN,MSGH_OUT,"msg handler",Color.green);
    tlogData.defineEvent2Type(SEND_IN,SEND_OUT,"send msg",Color.yellow);
    tlogData.defineEvent2Type(PAGEF_IN,PAGEF_OUT,"page falut",Color.blue);
    tlogData.defineEvent2Type(BSYNC_IN,BSYNC_OUT,"barrier sync 1",Color.gray);
    tlogData.defineEvent2Type(FLUSH_ALL_IN,FLUSH_ALL_OUT,"flush all",Color.orange);
    tlogData.defineEvent2Type(PAGE_INV_IN,PAGE_INV_OUT,"page inv",Color.pink);

    tlogData.defineEventType(START_EVENT,"call start",Color.green);
    tlogData.defineEventType(PAGEF_EVENT,"page fault",Color.red);
    
    tlogData.defineEventType(RMA_EVENT,"rma",Color.yellow);

    tlogData.defineEventType(MPI_SEND_EVENT,"mpi send",Color.black);
    tlogData.defineEventType(MPI_RECV_EVENT,"mpi receive",new Color(0.57f,0.17f,0.93f));
    tlogData.defineEventType(MPI_RMA_EVENT,"mpi rma",new Color(0.55f,0.27f,0.07f));
  }
}


