static char rcsid[] = "$Id: cpyin001.c,v 1.1.1.1 2004-02-06 18:15:07 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* copyin 001 :
 * copyin ưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


int	org;
int	prvt;
#pragma omp threadprivate(prvt)


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  prvt = org = -1;
  #pragma omp parallel copyin (prvt)
  {
    if (prvt != org) {
      #pragma omp critical
      {
	ERROR(errors);
      }
    }
  }

  prvt = org = 0;
  #pragma omp parallel copyin (prvt)
  {
    if (prvt != org) {
      #pragma omp critical
      {
	ERROR(errors);
      }
    }
  }

  prvt = org = 1;
  #pragma omp parallel copyin (prvt)
  {
    if (prvt != org) {
      #pragma omp critical
      {
	ERROR(errors);
      }
    }
  }


  if (errors == 0) {
    printf ("copyin 001 : SUCCESS\n");
    return 0;
  } else {
    printf ("copyin 001 : FAILED\n");
    return 1;
  }
}
