static char rcsid[] = "$Id: err_firstprivate_003.c,v 1.1.1.1 2004-02-06 18:15:08 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of firstprivate 003 :
 * scopeѿ firstprivate 
 */

#include "omniConfig.h"
#include <omp.h>


#define MAGICNO		100


int	errors = 0;
int	thds;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel firstprivate (prvt)
  {
    static int prvt = MAGICNO;

    #pragma omp barrier
    if (prvt != MAGICNO) {
      errors += 1;
    }
  }

  printf ("err_fistprivate 003 : FAILED, can not compile this program.\n");
  return 1;
}
