static char rcsid[] = "$Id: fstprvt021.c,v 1.2 2004-10-14 08:23:19 a-hasega Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* firstprivate 021 :
 * parallel for  firstprivate Ǥ뤳Ȥǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define MAGICNO	100


int	errors = 0;
int	thds;


int	prvt = MAGICNO;


main ()
{
  int	i;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel for firstprivate(prvt) schedule(static,1)
  for (i=0; i<thds; i++) {
    int	id = omp_get_thread_num ();

    if (prvt != MAGICNO) {
      #pragma omp critical
      errors += 1;
    }
    prvt = id;
    barrier (thds);
    if (prvt != id) {
      #pragma omp critical
      errors += 1;
    }
  }


  if (errors == 0) {
    printf ("firstprivate 021 : SUCCESS\n");
    return 0;
  } else {
    printf ("firstprivate 021 : FAILED\n");
    return 1;
  }
}
