static char rcsid[] = "$Id: prvt018.c,v 1.1.1.1 2004-02-06 18:15:11 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* private 018 :
 * parallel direcrive  private Ǥ뤳Ȥǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;

int	prvt;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  #pragma omp parallel private(prvt)
  {
    int	id = omp_get_thread_num ();

    prvt = id;

    #pragma omp barrier
    if (prvt != id) {
      #pragma omp critical
      errors += 1;
    }
  }


  if (errors == 0) {
    printf ("private 018 : SUCCESS\n");
    return 0;
  } else {
    printf ("private 018 : FAILED\n");
    return 1;
  }
}
