static char rcsid[] = "$Id: err_reduction_002.c,v 1.1.1.1 2004-02-06 18:15:12 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of reduction 002 :
 * private ѿФ reduction 
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel
  {
    int	i, rdct;

    #pragma omp for reduction(+:rdct)
    for (i=0;i<thds;i++) {
      rdct += i;
    }
  }


  printf ("err_reduction 002 : FAILED, can not compile this program.\n");
  return 1;
}
