static char rcsid[] = "$Id: shrd002.c,v 1.1.1.1 2004-02-06 18:15:13 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* shared 002 :
 * localѿФ롢shared ưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;


void
func1 (int *shrd)
{
  #pragma omp critical
  *shrd += 1;
  #pragma omp barrier

  if (*shrd != thds) {
    #pragma omp critical
    errors += 1;
  }
}


main ()
{
  int		shrd;
  static int	shrd2;


  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  shrd = 0;
  #pragma omp parallel shared(shrd)
  {
    #pragma omp critical
    shrd += 1;

    #pragma omp barrier

    if (shrd != thds) {
      #pragma omp critical
      errors += 1;
    }
  }


  shrd2 = 0;
  #pragma omp parallel shared(shrd2)
  {
    #pragma omp critical
    shrd2 += 1;

    #pragma omp barrier

    if (shrd2 != thds) {
      #pragma omp critical
      errors += 1;
    }
  }


  shrd = 0;
  #pragma omp parallel shared(shrd)
  func1 (&shrd);


  shrd2 = 0;
  #pragma omp parallel shared(shrd2)
  func1 (&shrd2);


  if (errors == 0) {
    printf ("shared 002 : SUCCESS\n");
    return 0;
  } else {
    printf ("shared 002 : FAILED\n");
    return 1;
  }
}
