static char rcsid[] = "$Id: err_threadprivate_002.c,v 1.1.1.1 2004-02-06 18:15:13 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of threadprivate 002 :
 * ݥѿμΤ threadprivate ꤷưǧ
 */

#include "omniConfig.h"
#include <omp.h>


int	errors = 0;
int	thds;


main ()
{
  int		i;
  static int	*x;

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);


  x = &i;
  #pragma omp threadprivate(*x)


  #pragma omp parallel
  {
    int	id = omp_get_thread_num ();

    *x = id;
    #pragma omp barrier

    if (*x != id) {
      errors += 1;
    }
  }


  printf ("err_threadprivate 002 : FAILED, can not compile this program.\n");
  return 1;
}
