static char rcsid[] = "$Id: thdprvt014.c,v 1.1.1.1 2004-02-06 18:15:14 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* threadprivate 014 :
 * threadprivateshortѿꤷưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;

short	i;
#pragma omp threadprivate (i)


void
func ()
{
  int	id = omp_get_thread_num ();

  i = id;
  #pragma omp barrier

  if (i != id) {
    #pragma omp critical
    errors += 1;
  }
  if (sizeof (i) != sizeof (short)) {
    #pragma omp critical
    errors += 1;
  }
}


main ()
{

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel
  {
    int	id = omp_get_thread_num ();

    i = id;
    #pragma omp barrier

    if (i != id) {
      #pragma omp critical
      errors += 1;
    }
    if (sizeof (i) != sizeof (short)) {
      #pragma omp critical
      errors += 1;
    }
  }

  #pragma omp parallel 
  func ();

  func ();


  if (errors == 0) {
    printf ("threadprivate 014 : SUCCESS\n");
    return 0;
  } else {
    printf ("threadprivate 014 : FAILED\n");
    return 1;
  }
}
