static char rcsid[] = "$Id: err_nesting_016.c,v 1.1.1.1 2004-02-06 18:15:15 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of netsting 016 :
 * ordered for
 */

#include "omniConfig.h"
#include <omp.h>


int	errors = 0;
int	thds;
int	i;


void
func ()
{
  #pragma omp ordered
  {
    int j;

#pragma omp for
    for (j=0; j<thds; j++) {
      i += 1;
    }
  }
}

main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel
  {
    int k;

    #pragma omp for ordered
    for (k=0; k<thds; k++){
      func ();
    }
  }


  printf ("err_nesting 016 : FAILED, can not compile this program.\n");
  return 1;
}
