static char rcsid[] = "$Id: err_nesting_031.c,v 1.1.1.1 2004-02-06 18:15:15 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* error case of netsting 031 :
 * critical  ordered ¸ߤ
 */

#include "omniConfig.h"
#include <omp.h>


int	errors = 0;
int	thds;
int	sum;


void 
func()
{
  #pragma omp critical
  {
    #pragma omp ordered
    {
      sum += 1;
    }
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel
  {
    int	i;

    #pragma omp for ordered
    for (i=0; i<thds; i++) {
      func ();
    }
  }


  printf ("err_nesting 031 : FAILED, can not compile this program.\n");
  return 1;
}
