static char rcsid[] = "$Id: flush010.c,v 1.1.1.1 2004-02-06 18:15:17 msato Exp $";
/* 
 * $RWC_Release$
 * $RWC_Copyright$
 */
/* flush 010:
 * singleλΰۤflushǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;
int	flag = 0;


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);
  omp_set_num_threads (2);


  #pragma omp parallel 
  {
    int id = omp_get_thread_num ();

    #pragma omp single
    {
      waittime (1);
      flag = 1;
    }

    if (flag == 0) {
      #pragma omp critical
      errors += 1;
    }
  }


  if (errors == 0) {
    printf ("flush 010 : SUCCESS\n");
    return 0;
  } else {
    printf ("flush 010 : FAILED\n");
    return 1;
  }
}
