/*
 * $Id: jexc_misc.c,v 1.1.1.1 2004-02-06 18:16:56 msato Exp $
 * $RWC_Release$
 * $RWC_Copyright$
 */

#include "jexc.h"

int nerrors = 0;

/* nonfatal error message */
/* VARARGS0 */
void
error EXC_VARARGS_DEF(char *, fmt)
{ 
    va_list args;

    ++nerrors;
    EXC_VARARGS_START(char *, fmt, args);
    vfprintf(stderr, fmt, args);
    va_end(args);
    fprintf(stderr, "\n" );
    fflush(stderr);
}

/* VARARGS0 */
void
warning EXC_VARARGS_DEF(char *, fmt)
{ 
    va_list args;

    fprintf(stderr,"warning: ");
    EXC_VARARGS_START(char *, fmt, args);
    vfprintf(stderr, fmt, args);
    va_end(args);
    fprintf(stderr, "\n" );
    fflush(stderr);
    /* check_nerrors(); */
}

/* compiler error: die */
/* VARARGS1 */
void
fatal EXC_VARARGS_DEF(char *, fmt)
{ 
    va_list args;
    
    fprintf(stderr, "fatal: " );
    EXC_VARARGS_START(char *, fmt, args);
    vfprintf(stderr, fmt, args);
    va_end(args);
    fprintf(stderr, "\n" );
    fflush(stderr);
    abort();
}



