// $Id: tlogData.java,v 1.1.1.1 2004-02-06 18:17:00 msato Exp $
// $RWC_Release$
// $RWC_Copyright$

public class tlogData {
  final static byte UNDEF = 0;	/* undefined */
  final static byte END = 1; 	/* END*/
  final static byte START = 2;
  final static byte RAW = 3; 	/* RAW information */
  final static byte EVENT = 4;
  final static byte EVENT_IN = 5;
  final static byte EVENT_OUT = 6;
  final static byte FUNC_IN = 7;
  final static byte FUNC_OUT = 8;
  final static byte BARRIER_IN = 9;
  final static byte BARRIER_OUT = 10;
  final static byte PARALLEL_IN = 11;
  final static byte PARALLEL_OUT = 12;
  final static byte CRITICAL_IN = 13;
  final static byte CRITICAL_OUT = 14;
  final static byte LOOP_INIT_EVENT = 15;
  final static byte LOOP_NEXT_EVENT = 16;
  final static byte SECTION_EVENT = 17;
  final static byte SIGNLE_EVENT = 18;

  byte type;
  int proc_id;
  int arg1,arg2;
  double timestamp;
  tlogData nested;  // for nested event
  
  public tlogData(byte type,int proc_id,int arg1,int arg2,double timestamp){
    this.type = type;
    this.proc_id = proc_id;
    this.arg1 = arg1;
    this.arg2 = arg2;
    this.timestamp = timestamp;
  }

  public void setNested(tlogData d){ nested = d; }
  public tlogData getNested() { return nested; }
      
  public String toString(){
    return "{type="+type+",id="+proc_id+",arg1="+arg1+",arg2="+arg2+
      ",time="+timestamp+"}";
  }
}

